/*
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
//#include "sin_table.h"

#define SQUARE_WAVE(x, DutyCycle) ((x<DutyCycle)?255:0)
#define SAWTOOTH_WAVE(x) (x)

volatile uint8_t g_Volume = 255;
volatile uint32_t g_PhaseStep = 1;
volatile uint32_t g_Phase = 0;

void Sleep(uint16_t Time)
{
	for(;Time>0; Time--)
		_delay_ms(1);
}

const uint16_t c_FreqTable[] =
{
	220, 233, 247, 262, 277, 294, 311, 330, 349, 370, 392, 415,
	440, 466, 494, 523, 554, 587, 622, 659, 698, 740, 784, 831,
	880
};


void SetFrequency(uint16_t Frequency);


int main(void)
{
	DDRB = (1<<PORTB0);
	DDRD = 0xff;

	SetFrequency(440);

	TCCR1A = 0;
	TCCR1B = (1<<CS10) | (1<<WGM12 ); // no prescaler
	TIMSK |= (1<<OCIE1A); // Timer-CTC interrupt
//	TIMSK |= (1<<OCIE1B);
	OCR1A = 500;
	sei();

	uint8_t i=0;
	while(1)
	{
		// Der Hack
//		if(i==0) SetFrequency(c_FreqTable[0]);
//		else if(i==1) SetFrequency(c_FreqTable[1]);
//		else if(i==2) SetFrequency(c_FreqTable[2]);
//		else if(i==3) SetFrequency(c_FreqTable[3]);
//		else if(i==4) SetFrequency(c_FreqTable[4]);
//		else if(i==5) SetFrequency(c_FreqTable[5]);
//		else if(i==6) SetFrequency(c_FreqTable[6]);
//		else if(i==7) SetFrequency(c_FreqTable[7]);
//		else if(i==8) SetFrequency(c_FreqTable[8]);
//		else if(i==9) SetFrequency(c_FreqTable[9]);
//		else if(i==10) SetFrequency(c_FreqTable[10]);
//		else if(i==11) SetFrequency(c_FreqTable[11]);
//		else if(i==12) SetFrequency(c_FreqTable[12]);
//		else if(i==13) SetFrequency(c_FreqTable[13]);
//		else if(i==14) SetFrequency(c_FreqTable[14]);
//		else if(i==15) SetFrequency(c_FreqTable[15]);
//		else if(i==16) SetFrequency(c_FreqTable[16]);
//		else if(i==17) SetFrequency(c_FreqTable[17]);
//		else if(i==18) SetFrequency(c_FreqTable[18]);
//		else if(i==19) SetFrequency(c_FreqTable[19]);
//		else if(i==20) SetFrequency(c_FreqTable[20]);
//		else if(i==21) SetFrequency(c_FreqTable[21]);
//		else if(i==22) SetFrequency(c_FreqTable[22]);
//		else if(i==23) SetFrequency(c_FreqTable[23]);
//		else if(i==24) SetFrequency(c_FreqTable[24]);
//		else PORTB = ~PORTB;

		SetFrequency(c_FreqTable[0]); // Das klappt nicht
		i++;
		if(i >= 25)
			i=0;
		Sleep(250);
	}

    return 0;
}


void SetFrequency(uint16_t Frequency)
{
	uint32_t tmp = (uint64_t)Frequency*0xffffffff / 8000UL;
	cli();
	g_PhaseStep = tmp;
	sei();
}

ISR(TIMER1_COMPA_vect)
{
	g_Phase += g_PhaseStep;

	uint8_t Index = (g_Phase >> 24);
	uint8_t Value = Index>159?64:0;

	PORTD = ((uint16_t)Value * g_Volume) >> 8;
}
